Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveExperiment.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveExperiment.cs	(revision 6004)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveExperiment.cs	(revision 6006)
@@ -28,10 +28,12 @@
 using HeuristicLab.Core;
 using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Clients.Hive {
-
+  [StorableClass]
   public partial class HiveExperiment : IDeepCloneable, IContent, IProgressReporter {
     private JobResultPoller jobResultPoller;
 
+    [Storable]
     private bool useLocalPlugins;
     public bool UseLocalPlugins {
@@ -40,4 +42,5 @@
     }
 
+    [Storable]
     private ExecutionState executionState;
     public ExecutionState ExecutionState {
@@ -51,4 +54,5 @@
     }
 
+    [Storable]
     private TimeSpan executionTime;
     public TimeSpan ExecutionTime {
@@ -62,17 +66,19 @@
     }
 
-    private HiveJob hiveJob;
-    public HiveJob HiveJob {
-      get { return hiveJob; }
+    [Storable]
+    private ItemCollection<HiveJob> hiveJobs;
+    public ItemCollection<HiveJob> HiveJobs {
+      get { return hiveJobs; }
       set {
-        DeregisterHiveJobEvents();
-        if (hiveJob != value) {
-          hiveJob = value;
-          RegisterHiveJobEvents();
-          OnHiveJobChanged();
-        }
-      }
-    }
-
+        DeregisterHiveJobsEvents();
+        if (hiveJobs != value) {
+          hiveJobs = value;
+          RegisterHiveJobsEvents();
+          OnHiveJobsChanged();
+        }
+      }
+    }
+
+    [Storable]
     private bool isProgressing;
     public bool IsProgressing {
@@ -87,4 +93,5 @@
 
     /** include jobs when refreshing **/
+    [Storable]
     private bool includeJobs;
     public bool IncludeJobs {
@@ -93,4 +100,5 @@
     }
 
+    [Storable]
     private bool refreshAutomatically;
     public bool RefreshAutomatically {
@@ -109,4 +117,5 @@
     }
 
+    [Storable]
     private IProgress progress;
     public IProgress Progress {
@@ -124,5 +133,4 @@
     protected HiveExperiment(HiveExperiment original, Cloner cloner) {
       cloner.RegisterClonedObject(original, this);
-      this.RootJobId = original.RootJobId;
       this.OwnerUserId = original.OwnerUserId;
       this.DateCreated = original.DateCreated;
@@ -158,15 +166,15 @@
     }
 
-    public event EventHandler HiveJobChanged;
-    private void OnHiveJobChanged() {
+    public event EventHandler HiveJobsChanged;
+    private void OnHiveJobsChanged() {
       if (jobResultPoller != null && jobResultPoller.IsPolling) {
         jobResultPoller.Stop();
         DeregisterResultPollingEvents();
       }
-      if (HiveJob != null && HiveJob.Job.Id != Guid.Empty) {
+      if (HiveJobs != null && HiveJobs.Count > 0 && GetAllHiveJobs().All(x => x.Job.Id != Guid.Empty)) {
         if (this.RefreshAutomatically)
           StartResultPolling();
       }
-      EventHandler handler = HiveJobChanged;
+      EventHandler handler = HiveJobsChanged;
       if (handler != null) handler(this, EventArgs.Empty);
     }
@@ -185,31 +193,43 @@
     #endregion
 
-    private void RegisterHiveJobEvents() {
-      if (HiveJob != null) {
-        HiveJob.JobStateChanged += new EventHandler(HiveJob_JobStateChanged);
-      }
-    }
-
-    private void DeregisterHiveJobEvents() {
-      if (HiveJob != null) {
-        HiveJob.JobStateChanged -= new EventHandler(HiveJob_JobStateChanged);
-      }
+    private void RegisterHiveJobsEvents() {
+      //if (HiveJobs != null) {
+      //  HiveJobs.JobStateChanged += new EventHandler(HiveJob_JobStateChanged);
+      //}
+    }
+
+    private void DeregisterHiveJobsEvents() {
+      //if (HiveJobs != null) {
+      //  HiveJobs.JobStateChanged -= new EventHandler(HiveJob_JobStateChanged);
+      //}
     }
 
     private void HiveJob_JobStateChanged(object sender, EventArgs e) {
-      if (this.HiveJob != null) {
-        this.RootJobId = HiveJob.Job.Id;
-      }
-    }
-
-    public Experiment GetExperiment() {
-      if (this.HiveJob != null) {
-        return HiveJob.OptimizerJob.OptimizerAsExperiment;
+      //if (this.HiveJobs != null) {
+      //  this.RootJobId = HiveJobs.Job.Id;
+      //}
+    }
+
+    public Experiment GetExperiment(int idx) {
+      if (this.HiveJobs != null) {
+        var hj = HiveJobs.ElementAtOrDefault(idx);
+        if (hj != null)
+          return hj.OptimizerJob.OptimizerAsExperiment;
       }
       return null;
     }
 
+    public void AddExperiment(Experiment experiment) {
+      if (this.HiveJobs == null) 
+        this.HiveJobs = new ItemCollection<HiveJob>();
+      this.HiveJobs.Add(new HiveJob(experiment));
+    }
+
     public void SetExperiment(Experiment experiment) {
-      this.HiveJob = new HiveJob(experiment);
+      if (this.HiveJobs == null)
+        this.HiveJobs = new ItemCollection<HiveJob>();
+      else
+        this.HiveJobs.Clear();
+      this.HiveJobs.Add(new HiveJob(experiment));
     }
 
@@ -225,5 +245,5 @@
     public void StartResultPolling() {
       if (jobResultPoller == null) {
-        jobResultPoller = new JobResultPoller(HiveJob, /*ApplicationConstants.ResultPollingInterval*/new TimeSpan(0, 0, 5)); //TODO: find a better place for ApplicationConstants
+        jobResultPoller = new JobResultPoller(HiveJobs, /*ApplicationConstants.ResultPollingInterval*/new TimeSpan(0, 0, 5)); //TODO: find a better place for ApplicationConstants
         RegisterResultPollingEvents();
       }
@@ -235,5 +255,5 @@
 
     public void StopResultPolling() {
-      if (jobResultPoller.IsPolling) {
+      if (jobResultPoller != null && jobResultPoller.IsPolling) {
         jobResultPoller.Stop();
       }
@@ -256,5 +276,5 @@
     private void jobResultPoller_JobResultReceived(object sender, EventArgs<IEnumerable<LightweightJob>> e) {
       foreach (LightweightJob lightweightJob in e.Value) {
-        HiveJob hj = hiveJob.GetHiveJobByJobId(lightweightJob.Id);
+        HiveJob hj = GetHiveJobById(lightweightJob.Id);
         if (hj != null) {
           DateTime lastJobDataUpdate = hj.Job.LastJobDataUpdate;
@@ -272,5 +292,5 @@
               } else {
                 if (lightweightJob.ParentJobId.HasValue) {
-                  HiveJob parentHiveJob = HiveJob.GetHiveJobByJobId(lightweightJob.ParentJobId.Value);
+                  HiveJob parentHiveJob = GetHiveJobById(lightweightJob.ParentJobId.Value);
                   parentHiveJob.UpdateChildOptimizer(optimizerJob, hj.Job.Id);
                 }
@@ -290,6 +310,15 @@
     }
 
+    public HiveJob GetHiveJobById(Guid jobId) {
+      foreach (HiveJob job in HiveJobs) {
+        HiveJob hj = job.GetHiveJobByJobId(jobId);
+        if (hj != null)
+          return hj;
+      }
+      return null;
+    }
+
     private void UpdateStats() {
-      var jobs = HiveJob.GetAllHiveJobs();
+      var jobs = GetAllHiveJobs();
       this.JobCount = jobs.Count();
       this.CalculatingCount = jobs.Count(j => j.Job.State == JobState.Calculating);
@@ -297,6 +326,14 @@
     }
 
-    private bool AllJobsFinished() {
-      return HiveJob.GetAllHiveJobs().All(j => j.Job.State == JobState.Finished
+    public IEnumerable<HiveJob> GetAllHiveJobs() {
+      var jobs = new List<HiveJob>();
+      foreach (HiveJob job in HiveJobs) {
+        jobs.AddRange(job.GetAllHiveJobs());
+      }
+      return jobs;
+    }
+
+    public bool AllJobsFinished() {
+      return GetAllHiveJobs().All(j => j.Job.State == JobState.Finished
                                             || j.Job.State == JobState.Aborted
                                             || j.Job.State == JobState.Failed);
@@ -308,5 +345,5 @@
 
     public void UpdateTotalExecutionTime() {
-      this.ExecutionTime = TimeSpan.FromMilliseconds(HiveJob.GetAllHiveJobs().Sum(x => x.Job.ExecutionTime.HasValue ? x.Job.ExecutionTime.Value.TotalMilliseconds : 0));
+      this.ExecutionTime = TimeSpan.FromMilliseconds(GetAllHiveJobs().Sum(x => x.Job.ExecutionTime.HasValue ? x.Job.ExecutionTime.Value.TotalMilliseconds : 0));
     }
     #endregion
@@ -320,4 +357,9 @@
       }
     }
+
+    public bool IsFinished() {
+      return HiveJobs != null
+        && HiveJobs.All(x => x.Job.DateFinished.HasValue && x.Job.DateCreated.HasValue);
+    }
   }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveServiceClient.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveServiceClient.cs	(revision 6004)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveServiceClient.cs	(revision 6006)
@@ -352,4 +352,7 @@
         
         [System.Runtime.Serialization.OptionalFieldAttribute()]
+        private System.Guid HiveExperimentIdField;
+        
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
         private bool IsParentJobField;
         
@@ -396,4 +399,21 @@
                     this.FinishWhenChildJobsFinishedField = value;
                     this.RaisePropertyChanged("FinishWhenChildJobsFinished");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public System.Guid HiveExperimentId
+        {
+            get
+            {
+                return this.HiveExperimentIdField;
+            }
+            set
+            {
+                if ((this.HiveExperimentIdField.Equals(value) != true))
+                {
+                    this.HiveExperimentIdField = value;
+                    this.RaisePropertyChanged("HiveExperimentId");
                 }
             }
@@ -569,7 +589,4 @@
         private string ResourceNamesField;
         
-        [System.Runtime.Serialization.OptionalFieldAttribute()]
-        private System.Guid RootJobIdField;
-        
         [System.Runtime.Serialization.DataMemberAttribute()]
         public int CalculatingCount
@@ -687,21 +704,4 @@
                     this.ResourceNamesField = value;
                     this.RaisePropertyChanged("ResourceNames");
-                }
-            }
-        }
-        
-        [System.Runtime.Serialization.DataMemberAttribute()]
-        public System.Guid RootJobId
-        {
-            get
-            {
-                return this.RootJobIdField;
-            }
-            set
-            {
-                if ((this.RootJobIdField.Equals(value) != true))
-                {
-                    this.RootJobIdField = value;
-                    this.RaisePropertyChanged("RootJobId");
                 }
             }
@@ -1732,4 +1732,7 @@
     {
         
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/TriggerLifecycle", ReplyAction="http://tempuri.org/IHiveService/TriggerLifecycleResponse")]
+        void TriggerLifecycle(bool force);
+        
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/AddAppointment", ReplyAction="http://tempuri.org/IHiveService/AddAppointmentResponse")]
         System.Guid AddAppointment(HeuristicLab.Clients.Hive.Appointment appointment);
@@ -1761,4 +1764,7 @@
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetLightweightChildJobs", ReplyAction="http://tempuri.org/IHiveService/GetLightweightChildJobsResponse")]
         System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightJob> GetLightweightChildJobs(System.Nullable<System.Guid> parentJobId, bool recursive, bool includeParent);
+        
+        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetLightweightExperimentJobs", ReplyAction="http://tempuri.org/IHiveService/GetLightweightExperimentJobsResponse")]
+        System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightJob> GetLightweightExperimentJobs(System.Guid experimentId);
         
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetJobData", ReplyAction="http://tempuri.org/IHiveService/GetJobDataResponse")]
@@ -1867,7 +1873,4 @@
         [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/GetResourceId", ReplyAction="http://tempuri.org/IHiveService/GetResourceIdResponse")]
         System.Guid GetResourceId(string resourceName);
-        
-        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IHiveService/TriggerLifecycle", ReplyAction="http://tempuri.org/IHiveService/TriggerLifecycleResponse")]
-        void TriggerLifecycle(bool force);
     }
     
@@ -1906,4 +1909,9 @@
         }
         
+        public void TriggerLifecycle(bool force)
+        {
+            base.Channel.TriggerLifecycle(force);
+        }
+        
         public System.Guid AddAppointment(HeuristicLab.Clients.Hive.Appointment appointment)
         {
@@ -1956,4 +1964,9 @@
         }
         
+        public System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightJob> GetLightweightExperimentJobs(System.Guid experimentId)
+        {
+            return base.Channel.GetLightweightExperimentJobs(experimentId);
+        }
+        
         public HeuristicLab.Clients.Hive.JobData GetJobData(System.Guid jobId)
         {
@@ -2130,9 +2143,4 @@
             return base.Channel.GetResourceId(resourceName);
         }
-        
-        public void TriggerLifecycle(bool force)
-        {
-            base.Channel.TriggerLifecycle(force);
-        }
     }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Job.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Job.cs	(revision 6004)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Job.cs	(revision 6006)
@@ -23,7 +23,7 @@
 using System.Collections.Generic;
 using HeuristicLab.Common;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Clients.Hive {
-
   public partial class Job : LightweightJob {
 
@@ -38,4 +38,5 @@
       this.IsParentJob = original.IsParentJob;
       this.FinishWhenChildJobsFinished = original.FinishWhenChildJobsFinished;
+      this.HiveExperimentId = original.HiveExperimentId;
     }
 
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine.Test/HeuristicLab.HiveEngine.Test.csproj
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine.Test/HeuristicLab.HiveEngine.Test.csproj	(revision 6004)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine.Test/HeuristicLab.HiveEngine.Test.csproj	(revision 6006)
@@ -126,4 +126,5 @@
   </ItemGroup>
   <ItemGroup>
+    <None Include="app_services.config" />
     <None Include="app.config" />
   </ItemGroup>
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine.Test/Program.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine.Test/Program.cs	(revision 6004)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine.Test/Program.cs	(revision 6006)
@@ -33,5 +33,5 @@
       #region Credentials
       ServiceLocator.Instance.Username = "cneumuel";
-      ServiceLocator.Instance.Password = "Stormlord105.";
+      ServiceLocator.Instance.Password = "YouWillNeverKnow";
       #endregion
 
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine/3.4/HeuristicLab.HiveEngine-3.4.csproj
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine/3.4/HeuristicLab.HiveEngine-3.4.csproj	(revision 6004)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine/3.4/HeuristicLab.HiveEngine-3.4.csproj	(revision 6006)
@@ -104,4 +104,7 @@
     <Reference Include="HeuristicLab.Clients.Common-3.3">
       <HintPath>..\..\..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.Clients.Common-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Clients.Hive.Views-3.4">
+      <HintPath>..\..\HeuristicLab.Clients.Hive.Views\3.4\obj\Debug\HeuristicLab.Clients.Hive.Views-3.4.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.Collections-3.3">
@@ -162,6 +165,5 @@
     <Compile Include="HiveEngine.cs" />
     <Compile Include="Exceptions\HiveEngineException.cs" />
-    <Compile Include="Properties\AssemblyInfo.cs" />
-    <None Include="Properties\AssemblyInfo.frame" />
+    <None Include="Properties\AssemblyInfo.cs.frame" />
   </ItemGroup>
   <ItemGroup>
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine/3.4/HiveEngine.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine/3.4/HiveEngine.cs	(revision 6004)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.HiveEngine/3.4/HiveEngine.cs	(revision 6006)
@@ -25,5 +25,5 @@
 
     [Storable]
-    public string ResourceIds { get; set; }
+    public string ResourceNames { get; set; }
 
     [Storable]
@@ -46,4 +46,18 @@
     }
 
+    [Storable]
+    private bool useLocalPlugins;
+    public bool UseLocalPlugins {
+      get { return useLocalPlugins; }
+      set { useLocalPlugins = value; }
+    }
+
+    [Storable]
+    private ItemCollection<HiveExperiment> hiveExperiments;
+    public ItemCollection<HiveExperiment> HiveExperiments {
+      get { return hiveExperiments; }
+      set { hiveExperiments = value; }
+    }
+
     private List<Plugin> onlinePlugins;
     public List<Plugin> OnlinePlugins {
@@ -60,5 +74,7 @@
     #region constructors and cloning
     public HiveEngine() {
-      ResourceIds = "HEAL";
+      ResourceNames = "HEAL";
+      HiveExperiments = new ItemCollection<HiveExperiment>();
+      Priority = 0;
     }
 
@@ -67,8 +83,9 @@
     protected HiveEngine(HiveEngine original, Cloner cloner)
       : base(original, cloner) {
-      this.ResourceIds = original.ResourceIds;
+      this.ResourceNames = original.ResourceNames;
       this.currentOperator = cloner.Clone(original.currentOperator);
       this.priority = original.priority;
       this.executionTimeOnHive = original.executionTimeOnHive;
+      this.useLocalPlugins = original.useLocalPlugins;
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -123,5 +140,4 @@
 
             IScope[] scopes = ExecuteOnHive(jobs, parentScopeClone, cancellationToken);
-            //IScope[] scopes = ExecuteLocally(jobs, parentScopeClone, cancellationToken);
             
             for (int i = 0; i < coll.Count; i++) {
@@ -186,18 +202,17 @@
     }
 
-    private IScope[] ExecuteLocally(EngineJob[] jobs, IScope parentScopeClone, CancellationToken cancellationToken) {
-      IScope[] scopes = new Scope[jobs.Length];
-
-      for (int i = 0; i < jobs.Length; i++) {
-        var job = (EngineJob)jobs[i].Clone();
-        job.Start();
-        while (job.ExecutionState != ExecutionState.Stopped) {
-          Thread.Sleep(100);
-        }
-        scopes[i] = ((IAtomicOperation)job.InitialOperation).Scope;
-      }
-
-      return scopes;
-    }
+    // testfunction:
+    //private IScope[] ExecuteLocally(EngineJob[] jobs, IScope parentScopeClone, CancellationToken cancellationToken) {
+    //  IScope[] scopes = new Scope[jobs.Length];
+    //  for (int i = 0; i < jobs.Length; i++) {
+    //    var job = (EngineJob)jobs[i].Clone();
+    //    job.Start();
+    //    while (job.ExecutionState != ExecutionState.Stopped) {
+    //      Thread.Sleep(100);
+    //    }
+    //    scopes[i] = ((IAtomicOperation)job.InitialOperation).Scope;
+    //  }
+    //  return scopes;
+    //}
 
     /// <summary>
@@ -211,4 +226,5 @@
       object locker = new object();
       IDictionary<Guid, int> jobIndices = new Dictionary<Guid, int>();
+      var hiveExperiment = new HiveExperiment();;
 
       try {
@@ -218,4 +234,12 @@
         int finishedCount = 0;
         int uploadCount = 0;
+
+        // create hive experiment
+        hiveExperiment.Name = "HiveEngine Run " + hiveExperiments.Count;
+        hiveExperiment.UseLocalPlugins = this.UseLocalPlugins;
+        hiveExperiment.ResourceNames = this.ResourceNames;
+        hiveExperiment.RefreshAutomatically = false;
+        hiveExperiment.Id = ServiceLocator.Instance.CallHiveService(s => s.AddHiveExperiment(hiveExperiment));
+        hiveExperiments.Add(hiveExperiment);
 
         // create upload-tasks
@@ -230,5 +254,5 @@
 
           uploadTasks.Add(Task.Factory.StartNew<Job>((keyValuePairObj) => {
-            return UploadJob(keyValuePairObj, parentScopeClone, cancellationToken, GetResourceIds());
+            return UploadJob(keyValuePairObj, parentScopeClone, cancellationToken, GetResourceIds(), hiveExperiment.Id);
           }, new KeyValuePair<int, EngineJob>(i, job), cancellationToken));
         }
@@ -313,5 +337,5 @@
 
         LogMessage(string.Format("All jobs finished (TotalExecutionTime: {0}).", executionTimes.Sum()));
-        DeleteJobs(jobIndices);
+        DeleteHiveExperiment(hiveExperiment.Id);
 
         return scopes;
@@ -319,5 +343,5 @@
       catch (OperationCanceledException e) {
         lock (locker) {
-          if (jobIndices != null) DeleteJobs(jobIndices);
+          if (jobIndices != null) DeleteHiveExperiment(hiveExperiment.Id);
         }
         throw e;
@@ -325,5 +349,5 @@
       catch (Exception e) {
         lock (locker) {
-          if (jobIndices != null) DeleteJobs(jobIndices);
+          if (jobIndices != null) DeleteHiveExperiment(hiveExperiment.Id);
         }
         LogException(e);
@@ -332,20 +356,12 @@
     }
 
-    private void DeleteJobs(IDictionary<Guid, int> jobIndices) {
-      if (jobIndices.Count > 0) {
-        TryAndRepeat(() => {
-          LogMessage(string.Format("Deleting {0} jobs on hive.", jobIndices.Count));
-          ServiceLocator.Instance.CallHiveService(service => {
-            foreach (Guid jobId in jobIndices.Keys) {
-              service.DeleteJob(jobId);
-            }
-            jobIndices.Clear();
-          });
-        }, 5, string.Format("Could not delete {0} jobs", jobIndices.Count));
-      }
+    private void DeleteHiveExperiment(Guid hiveExperimentId) {
+      TryAndRepeat(() => {
+        ServiceLocator.Instance.CallHiveService(s => s.DeleteHiveExperiment(hiveExperimentId));
+      }, 5, string.Format("Could not delete jobs"));
     }
 
     private static object locker = new object();
-    private Job UploadJob(object keyValuePairObj, IScope parentScopeClone, CancellationToken cancellationToken, List<Guid> resourceIds) {
+    private Job UploadJob(object keyValuePairObj, IScope parentScopeClone, CancellationToken cancellationToken, List<Guid> resourceIds, Guid hiveExperimentId) {
       var keyValuePair = (KeyValuePair<int, EngineJob>)keyValuePairObj;
       Job job = new Job();
@@ -370,4 +386,5 @@
         job.PluginsNeededIds = ServiceLocator.Instance.CallHiveService(s => PluginUtil.GetPluginDependencies(s, this.OnlinePlugins, this.AlreadyUploadedPlugins, neededPlugins, false));
         job.Priority = priority;
+        job.HiveExperimentId = hiveExperimentId;
 
         try {
@@ -396,5 +413,5 @@
     private List<Guid> GetResourceIds() {
       return ServiceLocator.Instance.CallHiveService(service => {
-        var resourceNames = ResourceIds.Split(';');
+        var resourceNames = ResourceNames.Split(';');
         var resourceIds = new List<Guid>();
         foreach (var resourceName in resourceNames) {
